# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ResourceSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'type': 'str',
        'deployment_id': 'str',
        'project_id': 'str',
        'properties': 'dict(str, object)'
    }

    attribute_map = {
        'name': 'name',
        'type': 'type',
        'deployment_id': 'deploymentId',
        'project_id': 'projectId',
        'properties': 'properties'
    }

    def __init__(self, name=None, type=None, deployment_id=None, project_id=None, properties=None):  # noqa: E501
        """ResourceSpecification - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._type = None
        self._deployment_id = None
        self._project_id = None
        self._properties = None
        self.discriminator = None
        self.name = name
        self.type = type
        if deployment_id is not None:
            self.deployment_id = deployment_id
        if project_id is not None:
            self.project_id = project_id
        if properties is not None:
            self.properties = properties

    @property
    def name(self):
        """Gets the name of this ResourceSpecification.  # noqa: E501

        Name of the resource  # noqa: E501

        :return: The name of this ResourceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ResourceSpecification.

        Name of the resource  # noqa: E501

        :param name: The name of this ResourceSpecification.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def type(self):
        """Gets the type of this ResourceSpecification.  # noqa: E501

        Type of the resource  # noqa: E501

        :return: The type of this ResourceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ResourceSpecification.

        Type of the resource  # noqa: E501

        :param type: The type of this ResourceSpecification.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def deployment_id(self):
        """Gets the deployment_id of this ResourceSpecification.  # noqa: E501

        Resource deployment id  # noqa: E501

        :return: The deployment_id of this ResourceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._deployment_id

    @deployment_id.setter
    def deployment_id(self, deployment_id):
        """Sets the deployment_id of this ResourceSpecification.

        Resource deployment id  # noqa: E501

        :param deployment_id: The deployment_id of this ResourceSpecification.  # noqa: E501
        :type: str
        """

        self._deployment_id = deployment_id

    @property
    def project_id(self):
        """Gets the project_id of this ResourceSpecification.  # noqa: E501

        Resource project id  # noqa: E501

        :return: The project_id of this ResourceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this ResourceSpecification.

        Resource project id  # noqa: E501

        :param project_id: The project_id of this ResourceSpecification.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def properties(self):
        """Gets the properties of this ResourceSpecification.  # noqa: E501

        Resource properties  # noqa: E501

        :return: The properties of this ResourceSpecification.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this ResourceSpecification.

        Resource properties  # noqa: E501

        :param properties: The properties of this ResourceSpecification.  # noqa: E501
        :type: dict(str, object)
        """

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
